#!/usr/bin/env python3

import rospy
import numpy as np
import math
from tf.transformations import euler_from_quaternion

# Import ROS messages
from nav_msgs.msg import OccupancyGrid, Odometry
from sensor_msgs.msg import LaserScan
from geometry_msgs.msg import Pose
from rosgraph_msgs.msg import Clock  # Needed for simulated time

# Your variable defination here

def get_rotation(msg):
    """Extract yaw from the odometry message."""
    # Your code here

    return yaw

def updateBinMap(xr, yr, theta, scan_msg, bin_map):
    """
    Update the occupancy grid using a binary approach.

    For each cell in the occupancy grid:
      - Convert the cell index (i,j) to physical coordinates (xa, ya).
      - Compute the Euclidean distance from the robot's position (xr, yr) to the cell.
      - Calculate the bearing from the robot to the cell (using arcsin and quadrant adjustments).
      - Use the bearing to select the corresponding laser scan index.
      - If the cell lies before the detected obstacle (free space), update it with free-space log-odds.
      - If the cell is approximately at the measured range, update it with occupied-space log-odds.
      - Clamp the cell value to the interval [0, 100].
    """
    # Your code here

    return bin_map

def updateLogOddsMap(xr, yr, theta, scan_msg, log_odds_map):
    """
    Update the log-odds occupancy grid map using a beam-by-beam approach.
    
    For each valid laser beam:
      - Calculate the absolute angle of the beam.
      - For each step along the beam until the measured range, update the cell with l_free.
      - Update the cell at the obstacle with l_occ.
    """
    # Your code here


    return log_odds_map

if __name__ == "__main__":
    rospy.init_node("Mapping", anonymous=True)
    
    # Wait for simulated time if use_sim_time is enabled.
    if rospy.get_param('/use_sim_time', False):
        rospy.loginfo("Waiting for simulated time to begin.")
        rospy.wait_for_message('/clock', Clock)
        rospy.loginfo("Simulated time started.")
    
    
    # Your code here
